;********************************************************************************
;*                    CONTROLE PARA MOTOR DE PASSO                              *
;*              RA0 A RA3 = SAIDA PARA O DRIVE DO MOTOR                         *
;*         RB4 - RB3  -        MODO                                             *
;*          0     0   -  INTERMITENTE RB5 = ESQUERDA - RB6 = DIREITA            *
;*          0     1   -  CONTINUO  RB5 = ESQUERDA - RB6 = DIREITA RB7 =PAUSE    *
;*          1     0   -  PULSO  RB5 = ESQUERDA - RB6 = DIREITA RB7 PULSOS       *
;*          1     1   -  ELETROEROSO                                           *
;*                                                                              *
;*            O MOTOR  DESLIGADO APS 2 SEGUNDOS SEM ATIVIDADE DO MOTOR        *
;*                                                                              *
;*                      DESENVOLVIDO POR JORGE ORLANDO CORAZZI                  *
;*                   MARVAN ELETRNICA IND. COM. E SERVIOS LTDA.               *
;********************************************************************************

	list 	p=16F84A
	radix  	dec
	#include	<p16f84.inc>  
	__config _xt_osc & _cp_on & _wdt_on & _pwrte_on

;######################### Definicoes  ##########################

motor	equ	10h
t1	equ	11h
vari	equ	12h

;######################### Inicio do programa ####################
	
	ORG	0

	bsf	status,rp0
	movlw	b'00010000'
	movwf	trisa
	movlw	b'11111101'
	movwf	trisb 
	bcf	status,rp0
	movlw	B'11011111'
	movwf	OPTION_REG
	CLRF	PORTA
	bcf	portb,1
	movlw	b'00110011'
	movwf	motor

;###### PROGRAMA #################################################

prog

	MOVLW	B'00011000'
	ANDWF	PORTB,W
	movwf	vari
	movlw	b'00011000'
	xorwf	vari,w
	BTFSC	STATUS,2
	GOTO	eletr
	movlw	b'00001000'
	xorwf	vari,w
	BTFSC	STATUS,2
	GOTO	prog1
	movlw	b'00010000'
	xorwf	vari,w
	BTFSC	STATUS,2
	GOTO	pulso
	btfsc	portb,5
	call	pas_d
	btfsc	portb,6
	call	pas_e
	goto	prog

;###### PROGRAMA1 ################################################

prog1

	btfss	portb,3
	goto	prog
	btfsc	portb,5
	goto	trv5
	btfsc	portb,6
	goto	trv6
	goto	prog1

trv5
	
	btfss	portb,3
	goto	prog
	btfsc	portb,6
	goto	trv6
	call	pas_d
PAUS5
	BTFSC	PORTB,7
	GOTO	PAUS5
	goto	trv5

trv6
	
	btfss	portb,3
	goto	prog
	btfsc	portb,5
	goto	trv5
	call	pas_e
PAUS6
	BTFSC	PORTB,7
	GOTO	PAUS6
	goto	trv6

;***************************************************************************************

PULSO

	btfss	portb,4
	goto	prog
	BTFSS	PORTB,7
	GOTO	PULSO
	btfsc	portb,5
	call	pas_d
	btfsc	portb,6
	call	pas_e
LPP
	BTFSC	PORTB,7
	GOTO	LPP
	GOTO	PULSO

;***************************************************************************************

eletr
	CLRWDT
	CALL	levant
star
	BTFSS	PORTB,5 ; start
	GOTO	star
ciclo
	call	abaixa
lel
	CLRWDT
	btfsc	portb,7 ; espera tenporizador
	goto	lel
	call	levant
	btfsc	portb,5 ; start / stop
	call	st_st
	MOVLW	B'00011000'
	ANDWF	PORTB,W
	XORLW	B'00011000'
	BTFSS	STATUS,2
	GOTO	PROG
	goto	ciclo
	goto eletr

levant
	CLRWDT
	btfsc	portb,6
	return
	call	pas_d
	goto	levant

abaixa
	CLRWDT
	btfsc	portb,7
	return
	call	pas_e
	goto	abaixa
	
st_st
	CLRWDT
	call	delay
	btfsc	portb,5
	goto	st_st
st_1
	CLRWDT
	call	delay
	btfss	portb,5
	goto	st_1
	return


;###### da um passo no motor p/direita ###########################

pas_d
	
	CLRWDT
	bcf	status,0
	btfsc	motor,7
	bsf	status,0
	rlf	motor
	movf	motor,w
	movwf	porta
	call	delay
	call	test
	return

;###### da um passo no motor p/esquerda ###########################

pas_e

	CLRWDT
	bcf	status,0
	btfsc	motor,0
	bsf	status,0
	rrf	motor
	movf	motor,w
	movwf	porta
	call	delay
	call	test
	return

;###### delay de 100 microsegundos ################################

delay
	movlw	62;31
	movwf	t1
	nop
	nop
loop
	decfsz	t1
	goto	loop
	return

;###### fica testando a entrada ra4 ###############################

test
	bcf	portb,1
lp_t
	btfss	porta,4
	goto	lp_t
	bsf	portb,1
	return

;###### FIM #######################################################

	end	
